$regfile = "m8def.dat"                                      '8
$crystal = 16000000                                         '16

$hwstack = 128
$swstack = 128
$framesize = 128

Config Watchdog = 2048
Stop Watchdog

'     
Config Lcd = 16 * 2
Config Lcdpin = Pin , Rs = Portd.6 , E = Portd.5 , Db4 = Portb.1 , Db5 = Portb.0 , Db6 = Portb.2 , Db7 = Portd.7
Cursor Off
Cls

'  

Deflcdchar 0 , 28 , 20 , 28 , 32 , 32 , 32 , 32 , 32        ' 
Deflcdchar 1 , 32 , 4 , 14 , 14 , 29 , 29 , 31 , 14         '
Deflcdchar 2 , 14 , 10 , 10 , 10 , 14 , 31 , 31 , 14        '


'  
'=============================================================================================
'=============================================================================================

'   Portc.2
Config Pinc.2 = Input
Config Timer0 = Timer , Prescale = 8
On Timer0 Over:
Stop Timer0

'#####################################

Const Min_time = 95                                         'Wert je nach Quarzfrequenz anpassen (siehe ticks)

Dim Count As Byte
Dim Signaltime(43) As Byte
Dim Humidityw As Word
Dim Temperaturew As Word
Dim Humsens_chksum As Byte

Dim Humiditys As String * 16
Dim Temperatures As String * 16


Dim Strstring As String * 14
Dim Ib As Byte



'###############################################################################

Declare Sub Read_timings
Declare Sub Humtemp_values
Declare Function Compare_chksum(byval Hsens_humidity As Word , Byval Hsens_temperature As Word , Byval Hsens_chksum As Byte) As Byte


Dim T As Word                                               ' 
Dim H As Word                                               ' 




'^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
'  





' 
Config Portb.4 = Output
Led1 Alias Portb.4

Config Portb.5 = Output
Led2 Alias Portb.5

Config Portc.0 = Output
Led3 Alias Portc.0

Config Portc.1 = Output
Led4 Alias Portc.1








'  
Config Portc.4 = Output                                     '  
Config Portc.5 = Output                                     '  

Rele1 Alias Portc.4                                         '  1,   
Rele2 Alias Portc.5                                         '  2,    


Config Portc.3 = Output                                     '  
Led Alias Portc.3

Config Portd.0 = Output                                     '    
Ledred Alias Portd.0

Config Portd.1 = Output                                     ' 
Backlight Alias Portd.1



Config Timer1 = Timer , Prescale = 1024
On Timer1 Overflow:
Stop Timer1


'  
Config Int0 = Falling
Config Int1 = Falling

Config Portd.4 = Input                                      '    

On Int0 Button                                              '   
On Int1 Encod                                               '   


'   
Dim A As Byte
'    
Dim N As Byte


'      
Dim Hum_eeprom As Eram Word                                 '    
Dim Temp_eeprom As Eram Word                                '    

Dim Temp As Word                                            '    
Dim Hum As Word                                             '    

Dim Tdispl As Word                                          '   
Dim Hdispl As Word                                          '   


Dim Tempdisplstr As String * 5
Dim Humdisplstr As String * 5

Dim Tsave As Word                                           '    
Dim Hsave As Word                                           '    

Dim Error As Byte                                           '   

Hum = Hum_eeprom                                            '  
Temp = Temp_eeprom                                          '   


Dim Flag1 As Bit                                            '   
Dim Flag2 As Bit                                            '   
Dim Ttemp As Word                                           '   
Dim Htemp As Word                                           '   

Cls
Backlight = 1                                               '  

'   :)
Led = 1
Ledred = 1
Waitms 20
Led = 0
Ledred = 0
Waitms 60
Led = 1
Ledred = 1
Waitms 20
Led = 0
Ledred = 0


'      
'      
Cls
Lcd "AVRproject.ru"
Lowerline
Lcd "ver. 21/08/14"
Wait 3
Cls


Gosub Test_info





' 
Enable Interrupts
Enable Int0
Enable Int1
Enable Timer1
 Enable Timer0
                             ' 
'================================================================================================
Backlight = 0                                               ' 



Do

'Disable Interrupts


Call Humtemp_values                                         '   


Gosub Compare                                               '      


'Enable Interrupts

If A = 0 Then                                               '   


'  If H = 111 Then                                           '  ,        
'    Ledred = 1
'    Lcd "Sensor"
'    Lowerline
'    Lcd "not respond"
'  Elseif H = 222 Then
'    Ledred = 1
'    Lcd "Sensor"
'    Lowerline
'    Lcd "is incorrect"
'  Elseif H = 123 Then
'    Ledred = 1
'    Lcd "CRC error"
'    Lowerline
'    Lcd "sensor is broken"
'
'  Else

    Ledred = 0




 If Compare_chksum(humidityw , Temperaturew , Humsens_chksum) = 1 Then

      Humiditys = Str(humidityw)
      Temperatures = Str(temperaturew)

      T = Temperaturew
      H = Humidityw

    Cls


    Strstring = "Temp: " + Format(temperatures , "0.0") + " C"
    'Strstring = Temperatures
    Locate 1 , 1
    Lcd Strstring

     If Flag1 = 1 Then
      Locate 1 , 16
      Lcd Chr(2)                                            '    
     End If


   Strstring = "Hmdt: " + Format(humiditys , "0.0") + " %"
   'Strstring = Humiditys
   Locate 2 , 1
   Lcd Strstring

     If Flag2 = 1 Then
      Locate 2 , 16
      Lcd Chr(1)
     End If
  Ledred = 0                                                '  

  Else

   Errore:                                                  '      0
   Rele1 = 0
   Rele2 = 0
  Ledred = 1                                                '  


  Strstring = "DHT Read-Error"
   Cls
   Locate 1 , 1
   Lcd Strstring

  Wait 2
  Cls
   Locate 1 , 1
   Lcd "Restart!"
  Start Watchdog
  End If




'    Lcd "Temp: " ; T ; "C"
'     If Flag1 = 1 Then
'     Locate 1 , 16
'     Lcd Chr(2)                                             '    
'     End If
'    Lowerline
'    Lcd "Hmdt: " ; H ; "%"
'     If Flag2 = 1 Then
'     Locate 2 , 16
'     Lcd Chr(1)
'     End If


Led = 1                                                     '  

If T < Temp Then
 Led1 = 1
 Led2 = 0

 Elseif T = Temp Then
 Led2 = 1


 Elseif T > Temp Then
 Led3 = 1
 Led2 = 0
End If


If H < Hum Then
 Led4 = 1
End If


Waitms 30
 Led = 0
 Waitms 100
 Led1 = 0
 Led3 = 0
 Led4 = 0





Wait 3

End If




'Dim Tempstr1 As String * 5
'Tempstr1 = Str(temp)
'Strstring = Format(tempstr1 , "0.0")


'Dim Tempdisplstr As String * 5
'Dim Humdisplstr As String * 5

If A = 1 Then
    Timer1 = 0

     Do

     Tempdisplstr = Str(tdispl)
     Strstring = Format(tempdisplstr , "0.0")

     Cls
     ' 
     Lcd "opo T"
     Lowerline
     Lcd Strstring ; Chr(0) ; "C"
     Waitms 400
 Loop Until A <> 1
End If


 If A = 2 Then
    Timer1 = 0

     Do

     Humdisplstr = Str(hdispl)
    Strstring = Format(humdisplstr , "0.0")

     Cls
     ' H
     Lcd "opo H"
     Lowerline
     Lcd Strstring ; " %"
     Waitms 400
    Loop Until A <> 2
End If


Loop

End






' 
'===================================================================================================================
'===================================================================================================================
'===================================================================================================================




Sub Read_timings

   Count = 1

   Config Pinc.2 = Output : Portc.2 = 0                     ' request data
   Waitms 20                                                ' wait 20 ms
   Config Pinc.2 = Input                                    ' wait for data, receive data

   While Count < 43                                         'collect 42 timings / signals

      Bitwait Pinc.2 , Set                                  'signal goes high > start timer
      Start Timer0
      Bitwait Pinc.2 , Reset                                'signal goes low  > stop timer
      Stop Timer0
      Signaltime(count) = Tcnt0                             'store number of ticks per signal in Signaltime byte

      Tcnt0 = 0
      Incr Count

  Wend


End Sub

'###############################################################################
'Humidity and temperature values
'  transform timings into bits (40 timings > 40 Bits)
'  every time (in ticks) > Min_time >>> Bit = 1
'  every time (in ticks) < Min_time >>> Bit = 0
'  first word contains humidity
'  second word contains temperature
'  last byte contains checksum

Sub Humtemp_values

   Local X As Byte

   Humidityw = 0
   Temperaturew = 0
   Humsens_chksum = 0

   Call Read_timings

   For Count = 3 To 42                                      ' Erste zwei Bits berspringen

      Select Case Count

         Case 3 To 18
            X = 18 - Count
            If Signaltime(count) > Min_time Then Toggle Humidityw.x

         Case 19 To 34
            X = 34 - Count
            If Signaltime(count) > Min_time Then Toggle Temperaturew.x

         Case 34 To 42
            X = 42 - Count
            If Signaltime(count) > Min_time Then Toggle Humsens_chksum.x

      End Select

  Next

End Sub

'###############################################################################
' Calculate Checksum and compare with trasnmitted value


Function Compare_chksum(byval Hsens_humidity As Word , Byval Hsens_temperature As Word , Byval Hsens_chksum As Byte) As Byte

   Local Chksum As Byte

   Chksum = Low(hsens_humidity ) + High(hsens_humidity )
   Chksum = Chksum + Low(hsens_temperature)
   Chksum = Chksum + High(hsens_temperature)

   If Chksum = Hsens_chksum Then
      Compare_chksum = 1
   Else
      Compare_chksum = 0
   End If

End Function



   Over:                                                    '   0

    Goto Errore
   Return




                           '   
'**************************************************************************************************
Overflow:
 Stop Timer1                                                '   
 Timer1 = 0

  If N = 0 Then
   Start Timer1
   N = 1
  Else
   Backlight = 0                                            ' 
   N = 0
    A = 0                                                   ' 
   Stop Timer1
   Timer1 = 0
  End If
Return




                       '/ 
'**************************************************************************************************
Compare:                                                    '   / 

' If H = 111 Or H = 222 Or H = 123 Then                      '        
'   Rele1 = 0
'   Rele2 = 0
'   Goto Extcompare
' End If


If Flag1 = 0 Then                                           ' 1  
  If T < Temp Then                                          '    
  Rele1 = 1                                                 ' 
  Flag1 = 1                                                 ' 
  End If
End If

If Flag1 = 1 Then                                           '   1,  
  Ttemp = Temp + 1                                          '  1 
  If T >= Ttemp Then                                        '  
   Rele1 = 0                                                ' 
   Flag1 = 0                                                '  
  End If
End If

'    
If Flag2 = 0 Then
  If H > Hum Then                                           '    
  Rele2 = 1                                                 ' 
  Flag2 = 1
  End If
End If

If Flag2 = 1 Then
  Htemp = Hum - 1
  If H =< Htemp Then
   Rele2 = 0
   Flag2 = 0
  End If
End If

Extcompare:

Return






                       '  
'**************************************************************************************************
Encod:

 Backlight = 1                                              '  
 Stop Timer1
 Timer1 = 0
 Start Timer1


 If A > 0 Then
  Waitms 2                                                  '    
  If Pind.3 = 0 Then
   If Pind.4 = 0 Then                                       '    (  ) 

    If A = 1 Then
     Incr Tdispl
       If Tdispl > 1000 Then
        Tdispl = 1000
       End If

    End If

    If A = 2 Then
     Incr Hdispl

      If Hdispl > 1000 Then
        Hdispl = 1000
       End If

    End If

   Else

    If A = 1 Then
     Decr Tdispl
     If Tdispl > 20000 Then
      Tdispl = 0
     End If

    End If

    If A = 2 Then
     Decr Hdispl

     If Hdispl > 2000 Then
      Hdispl = 0
     End If

    End If


   End If
  End If
 Waitms 4
 Gifr = 128                                                 '    INT1
 End If


Return




Button:                                                     ' 

 Timer1 = 0                                                 ' 
 Start Timer1                                               ' 
 Backlight = 1                                              '  
'  , no comments ;)
   If A = 2 Then
    A = 0

    '          
    If Tdispl <> Temp Then
        Temp = Tdispl
        Temp_eeprom = Temp
        Cls
        ' 
        Lcd "Te. acaa"
         Ledred = 1
         Waitms 50
         Ledred = 0
        Wait 1

    End If

    If Hdispl <> Hum Then
       Hum = Hdispl
       Hum_eeprom = Hum
       Cls
       ' 
       Lcd "Ba. acaa"
        Ledred = 1
        Waitms 50
        Ledred = 0

       Wait 1

    End If
      Waitms 50
      Gifr = 64

        'Pulseout Portb , 3 , 1000
        Sound , Portb.3 , 600 , 500
      Goto Argh                                             '   ,    

  End If


   'Pulseout Portb , 3 , 10000
   Sound , Portb.3 , 200 , 500

   If A = 1 Then
    A = 2
    Hdispl = Hum
   End If

   If A = 0 Then
    A = 1
    Tdispl = Temp
   End If



Argh:
 Ledred = 1
 Waitms 30
 Ledred = 0

 Waitms 100                                                 '  
 Gifr = 64                                                  '   

Return


End















Test_info:

                   '     
'#####################################################################################
Cls
Rem  
Lcd "TECT HAPEBATE"
Rele1 = 1
Wait 3
Rele1 = 0
Waitms 800

Cls

Rem  
Lcd "TECT BEHTᥥ"
Rele2 = 1
Wait 2
Rele2 = 0
Waitms 200
Cls

Cls

'Strstring = "Hmdt: " + Format(humiditys , "0.0") + " %"

Dim Tempstr1 As String * 5
Tempstr1 = Str(temp)
Strstring = Format(tempstr1 , "0.0")

Rem 
Rem :
Lcd "caoea"
Lowerline
Lcd "e:"
Locate 2 , 7
Lcd Strstring ; Chr(0)

Wait 2
Cls


Dim Humstr1 As String * 5
Humstr1 = Str(hum)
Strstring = Format(humstr1 , "0.0")

Rem 
Rem :
Lcd "caoea"
Lowerline
Lcd "a:"
Locate 2 , 7
Lcd Strstring ; "%"

Wait 2
Cls

'#####################################################################################
                        '  

'    
Led = 1
Ledred = 1
Waitms 20
Led = 0
Ledred = 0
Waitms 60
Led = 1
Ledred = 1
Waitms 20
Led = 0
Ledred = 0


Return